import * as glob from 'glob';
import { ICreateTsIndexCliOption, ICreateTsIndexOption } from './ICreateTsIndexOption';
export declare class CreateTsIndexOption {
    static factory({ option, partialOption, }: {
        option?: ICreateTsIndexOption;
        partialOption?: Partial<ICreateTsIndexOption>;
    }): CreateTsIndexOption;
    static cliOptionBuilder(args: ICreateTsIndexCliOption, cwd: string): ICreateTsIndexOption;
    static getDefailtICreateTsIndexOption(cwd?: string): ICreateTsIndexOption;
    static getOption(passed: Partial<ICreateTsIndexOption>): CreateTsIndexOption;
    /** enable file first */
    readonly fileFirst: boolean;
    /** add newline on EOF */
    readonly addNewline: boolean;
    /** add semicolon on every export statement */
    readonly useSemicolon: boolean;
    /** add timestamp on creation comment */
    readonly useTimestamp: boolean;
    /** current working directory add to creation work */
    readonly includeCWD: boolean;
    /** exclude directories */
    readonly excludes: string[];
    /** file exclude pattern */
    readonly fileExcludePatterns: string[];
    /** file exclude by extension */
    readonly targetExts: string[];
    /** glob option */
    readonly globOptions: glob.IOptions;
    /** quote mark " or ' */
    readonly quote: string;
    /** disply verbose logging message */
    readonly verbose: boolean;
    constructor(fileFirst: boolean | ICreateTsIndexOption, addNewline?: boolean, useSemicolon?: boolean, useTimestamp?: boolean, includeCWD?: boolean, excludes?: string[], fileExcludePatterns?: string[], targetExts?: string[], globOptions?: glob.IOptions, quote?: string, verbose?: boolean);
}
